<script lang="ts" context="module">
  import type { Value as ValueT } from "./Value";
  import { ValueType, Zero } from "./Value";

  export type RegConf = {
    Zero?: null;
    Static?: ValueT;
    Noise?: { pos: number; scale: number };

    // // Special
    PortId?: null;

    // // Meta
    Cast?: [RegConf, ValueType];
    Remap?: [RegConf, { start: ValueT; end: ValueT }];
    List?: Array<[ValueT, RegConf]>;
  };
</script>

<script lang="ts">
  import EditValue from "./EditValue.svelte";
  import TypeSelector from "./TypeSelector.svelte";
  import { createEventDispatcher } from "svelte";
  import { GetVal } from "./utils";
  const dispatch = createEventDispatcher();

  function update(c: RegConf) {
    dispatch("value", c);
  }

  function setType(type: string) {
    if (conf[type] != undefined) {
      return;
    }

    switch (type) {
      case "Zero":
        update({ Zero: null });
        break;
      case "Static":
        update({ Static: Zero });
        break;
      case "Noise":
        update({ Noise: { pos: 0, scale: 0 } });
        break;
      case "PortId":
        update({ PortId: null });
        break;
      case "Cast":
        update({ Cast: [conf, ValueType.U16] });
        break;
      case "Remap":
        update({ Remap: [conf, { start: Zero, end: Zero }] });
        break;
      case "List":
        update({ List: [[{ U16: 0 }, conf]] });
        break;

      default:
        console.warn("Unhandled type", type);
    }
  }

  export let conf: RegConf;
  $: type = Object.keys(conf)[0];
  let currIdx = 0;
</script>

<label>
  <span> Change to type: </span>
  <select value={type} on:input={(e) => setType(GetVal(e))}>
    <option>Zero</option>
    <option>Static</option>
    <option>Noise</option>
    <option>PortId</option>
    <option>Cast</option>
    <option>Remap</option>
    <option>List</option>
  </select>
</label>

{#if conf.Static}
  <EditValue
    value={conf.Static}
    on:value={(e) => {
      update({ Static: e.detail });
    }}>Static value:</EditValue
  >
{:else if conf.Remap}
  <h2>Remap value</h2>
  <hr />
  <svelte:self
    conf={conf.Remap[0]}
    on:value={(e) =>
      update({
        Remap: [e.detail, conf.Remap[1]],
      })}
  />
  <hr />
  <EditValue
    value={conf.Remap[1].start}
    on:value={(e) =>
      update({
        Remap: [
          conf.Remap[0],
          {
            ...conf.Remap[1],
            start: e.detail,
          },
        ],
      })}>Output for <span class="tt">in = 0</span>:</EditValue
  >
  <EditValue
    value={conf.Remap[1].end}
    on:value={(e) =>
      update({
        Remap: [
          conf.Remap[0],
          {
            ...conf.Remap[1],
            end: e.detail,
          },
        ],
      })}>Output for <span class="tt">in = 1</span>:</EditValue
  >
{:else if conf.Noise}
  <h3>Random noise</h3>
  <label>
    <span>Scale</span>
    <input
      type="number"
      step=".2"
      value={conf.Noise.scale}
      on:input={(e) =>
        update({
          Noise: {
            ...conf.Noise,
            scale: +GetVal(e),
          },
        })}
    />
  </label>
  <label>
    <span>Position</span>
    <input
      type="number"
      step=".5"
      value={conf.Noise.pos}
      on:input={(e) =>
        update({
          Noise: {
            ...conf.Noise,
            pos: +GetVal(e),
          },
        })}
    />
  </label>
{:else if conf.Cast}
  <svelte:self
    conf={conf.Cast[0]}
    on:value={(e) =>
      update({
        Cast: [e.detail, conf.Cast[1]],
      })}
  />
  <div class="lbl">
    <span>Casting as:</span>
    <TypeSelector
      value={conf.Cast[1]}
      on:value={(e) =>
        update({
          Cast: [conf.Cast[0], e.detail],
        })}
    />
  </div>
{:else if conf.Zero === null}
  Zero (0)
{:else if conf.PortId === null}
  Port Id
{:else if conf.List}
  <h1>Sum of all values :</h1>
  <div style="font-size: 2em; text-align: center">
    <button on:click={() => currIdx--}>&lt;</button>
    {#each conf.List as _, i}
      <button on:click={() => (currIdx = i)}>
        {#if currIdx == i}
          o
        {:else}
          &bull;
        {/if}
      </button>
    {/each}
    <button on:click={() => currIdx++}>&gt;</button>
  </div>

  {#if conf.List[currIdx]}
    <EditValue
      value={conf.List[currIdx][0]}
      on:value={(e) => {
        const List = [...conf.List]; // Shallow copy array
        List[currIdx] = [e.detail, conf.List[currIdx][1]];
        update({ List });
      }}
    >
      Factor:
    </EditValue>
    <svelte:self
      conf={conf.List[currIdx][1]}
      on:value={(e) => {
        const List = [...conf.List]; // Shallow copy array
        List[currIdx] = [conf.List[currIdx][0], e.detail];
        update({ List });
      }}
    />
  {:else}
    <button
      on:click={() => {
        currIdx = conf.List.length;
        update({
          List: [...conf.List, [{ I16: 0 }, { Zero: null }]],
        });
      }}
    >
      Add new entry
    </button>
  {/if}
{:else}
  UNKNOWN CONFIGURATION: {JSON.stringify(conf)}
{/if}

<style lang="sass">
	.tt
		font-family: monospace
		margin: 0 5px
		font-size: 1.1em

	h1, h2, h3
		text-align: center

	label, .lbl
		display: flex
		align-items: baseline

		span
			flex: 1
</style>
